<template>
  <div class="white-block">
    <div class="padding" @click="showOfficialInfo">
      <h3>Публичность
        <img src="static/img/head/content/tooltip.png"
             v-tooltip.right-start="{
          content:
          '<p>' + 'Публичное должностное лицо - лицо, на которое возложены (были ' +
          'возложены) важные государственные функции в иностранном' +
          'государстве. Служащие среднего и низшего уровня к таким' +
          'лицам не относятся.' + '</p>' +

          '<p>' + 'Должностное лицо публичной международной организации -' +
          'международный гражданский служащий, либо любое лицо,' +
          'уполномоченное такой организацией действовать от ее имени.' + '</p>' +

          '<p>' + 'Публичные должностные лица РФ - лица, замещающие (занимающие)' +
          'государственные должности РФ, должности членов Совета' +
          'директоров Банка России, должности федеральной государственной' +
          'службы, назначение на которые и освобождение от которых' +
          'осуществляются Президентом России или Правительством РФ,' +
          'должности в Центральном банке РФ, государственных корпорациях' +
          'и иных организациях, созданных Российской Федерацией на' +
          'основании федеральных законов, включенные в перечни' +
          'должностей, определяемые Президентом РФ.' + '</p>',
          targetClasses: 'registration-tooltip-icon',
          delay: {show: 250, hide: 500},
          classes: 'registration-tooltip',
          trigger: 'click hover',
          }"
             @click.stop="$event.preventDefault"

        >
        <img style="float: right; margin-top: -5px;" :src="arrow">
      </h3>
    </div>
    <hr/>
    <div class="padding" v-show="officialInfoShow">

      <div class="row">
        <div class="column">
          <label for="officialState">Являетесь ли вы или ваши близкие родственники иностранным публичным должностным
            лицом?</label>
          <multiselect v-model="fieldOfficialState"
                       :options="officialStateStatus"
                       :searchable="false"
                       :close-on-select="true"
                       :show-labels="false"
                       placeholder=""
                       id="officialState"
                       :preserve-search="true"
                       label="title"
                       track-by="id"
                       @input="getOfficialState"
                       :vValidateRules = "'required'"
                       name="officialState"
                       :value="officialStateLoader"
                       data-code="publicity.officialStateNotInAvailableRange, publicity.officialOwnerIsMeNotInAvailableRange"
          >
          </multiselect>
          <validate-message v-show="vErrors.has('officialState')">
            {{ vErrors.first('officialState') }}
          </validate-message>
        </div>
      </div>

      <!--<transition name="slide-fade">-->
      <div class="row" v-if="fieldOfficialState.status">
        <div class="columns">
          <label for="officialName">Укажите должность иностранного публичного лица:</label>
          <input type="text"
                 name="officialName"
                 id="officialName"
                 :class="getValidateClass('officialName')"
                 v-model="$user.publicity.officialName"
                 v-validate="'required|min:2|max:90'"
                 data-code="publicity.officialNameTooShort, publicity.officialNameTooLong"
          />
          <validate-message v-show="vErrors.has('officialName')">
            {{ vErrors.first('officialName') }}
          </validate-message>
        </div>
      </div>
      <!--</transition>-->

      <div class="row">
        <div class="column">
          <label for="internationalOrganizationState">Являетесь ли вы или ваши близкие родственники должностным лицом
            публичной международной организации?</label>
          <multiselect v-model="fieldInternationalOrganizationState"
                       :options="internationalOrganizationStateStatus"
                       :searchable="false"
                       :close-on-select="true"
                       :show-labels="false"
                       placeholder=""
                       id="internationalOrganizationState"
                       :preserve-search="true"
                       label="title"
                       track-by="id"
                       @input="getInternationalOrganizationState"
                       :vValidateRules = "'required'"
                       name="internationalOrganizationState"
                       :value="internationalOrganizationStateLoader"
                       data-code="publicity.internationalOrganizationStateNotInAvailableRange, publicity.internationalOrganizationOwnerIsMeNotInAvailableRange"
          >
          </multiselect>
          <validate-message v-show="vErrors.has('internationalOrganizationState')">
            {{ vErrors.first('internationalOrganizationState') }}
          </validate-message>
        </div>
      </div>

      <!--<transition name="slide-fade">-->
      <div class="row" v-if="fieldInternationalOrganizationState.status">
        <div class="columns">
          <label for="internationalOrganizationName">Укажите должность лица и наименование международной
            организации:</label>
          <input type="text"
                 name="internationalOrganizationName"
                 id="internationalOrganizationName"
                 :class="getValidateClass('internationalOrganizationName')"
                 v-model="$user.publicity.internationalOrganizationName"
                 v-validate="'required|min:2|max:90'"
                 data-code="publicity.internationalOrganizationNameTooShort, publicity.internationalOrganizationNameTooLong"
                 />
          <validate-message v-show="vErrors.has('internationalOrganizationName')">
            {{ vErrors.first('internationalOrganizationName') }}
          </validate-message>
        </div>
      </div>
      <!--</transition>-->

      <div class="row">
        <div class="columns">
          <label for="officialRussiaState">Являетесь ли вы или ваши близкие родственники публичным должностным лицом
            Российской Федерации? </label>
          <multiselect v-model="fieldOfficialRussiaState"
                       :options="officialRussiaStateStatus"
                       :searchable="false"
                       :close-on-select="true"
                       :show-labels="false"
                       placeholder=""
                       id="officialRussiaState"
                       :preserve-search="true"
                       label="title"
                       track-by="id"
                       @input="getOfficialRussiaState"
                       :vValidateRules = "'required'"
                       name="officialRussiaState"
                       :value="officialRussiaStateLoader"
                       data-code="publicity.officialRussiaStateNotInAvailableRange, publicity.officialRussiaOwnerIsMeNotInAvailableRange"
          >
          </multiselect>
          <validate-message v-show="vErrors.has('officialRussiaState')">
            {{ vErrors.first('officialRussiaState') }}
          </validate-message>
        </div>
      </div>

      <!--<transition name="slide-fade">-->
      <div class="row" v-if="fieldOfficialRussiaState.status">
        <div class="columns">
          <label for="officialRussiaName">Укажите должность лица и наименование Российской организации:</label>
          <input type="text"
                 name="officialRussiaName"
                 id="officialRussiaName"
                 :class="getValidateClass('officialRussiaName')"
                 v-model="$user.publicity.officialRussiaName"
                 v-validate="'required|min:2|max:90'"
                 data-code="publicity.officialRussiaNameTooShort, publicity.officialRussiaNameTooLong"
                 />
          <validate-message v-show="vErrors.has('officialRussiaName')">
            {{ vErrors.first('officialRussiaName') }}
          </validate-message>
        </div>
      </div>
      <!--</transition>-->

      <div class="row">
        <div class="column">
          <label for="benefitsOfAnotherPerson">Действуете ли вы к выгоде другого лица (выгодоприобретателя) в том числе на
            основании агентского договора, договора поручения, комиссии, доверительного управления?</label>
          <multiselect v-model="fieldBenefitsOfAnotherPerson"
                       :options="benefitsOfAnotherPersonStatus"
                       :searchable="false"
                       :close-on-select="true"
                       :show-labels="false"
                       placeholder=""
                       id="benefitsOfAnotherPerson"
                       :preserve-search="true"
                       label="title"
                       track-by="id"
                       @input="getBenefitsOfAnotherPerson"
                       :vValidateRules = "'required'"
                       name="benefitsOfAnotherPerson"
                       :value="benefitsOfAnotherPerson"
                       data-code="publicity.benefitsOfAnotherPersonNotInAvailableRange"
          >
          </multiselect>
          <validate-message v-show="vErrors.has('benefitsOfAnotherPerson')">
            {{ vErrors.first('benefitsOfAnotherPerson') }}
          </validate-message>
        </div>
      </div>

    </div>
  </div>
</template>

<script>
  import UserGetter from '@/mixins/User/UserGetterMixin'
  import UserSetter from '@/mixins/User/UserSetterMixin'
  import UserErrorText from '@/mixins/User/UserErrorTextMixin'
  import GetValidateClass from '@/mixins/Validation/GetValidateClassMixin'
  import IndicatorRegistration from '@/mixins/IndicatorRegistration'
  import { REQUIRED_FIELD, MIN_LENGHT, MAX_LENGHT } from '@/components/Validators/CustomVeeValidateMessage'
  import Multiselect from '@/UI/Multiselect'
  import ValidateMessage from '@/components/Validators/ValidateMessage'
  import ErrorHandleMixin from '@/mixins/ErrorHandleMixin'

  let statusResident = [
    {id: 1, title: 'Нет', status: false},
    {id: 2, title: 'Да', status: true},
    {id: 3, title: 'Да, супруг(а) или близкий родственник', status: true}
  ]

  export default {
    name: 'publicity-information',
    mixins: [
      UserGetter,
      UserSetter,
      UserErrorText,
      GetValidateClass,
      IndicatorRegistration,
      ErrorHandleMixin
    ],
    data () {
      return {
        officialInfoShow: false,
        fieldOfficialState: [{id: 1, title: 'Нет', status: false}],
        officialStateStatus: statusResident,
        fieldInternationalOrganizationState: [{id: 1, title: 'Нет', status: false}],
        internationalOrganizationStateStatus: statusResident,
        fieldOfficialRussiaState: [{id: 1, title: 'Нет', status: false}],
        officialRussiaStateStatus: statusResident,
        fieldBenefitsOfAnotherPerson: [{id: 1, title: 'Нет', status: false}],
        benefitsOfAnotherPersonStatus: [
          {id: 1, title: 'Нет', status: false},
          {id: 2, title: 'Да', status: true}
        ],
        arrow: 'static/img/loan/modal-down.png'
      }
    },
    computed: {
      officialStateLoader () {
        if ((this.$user.publicity.officialState === false) && (this.$user.publicity.officialOwnerIsMe === false)) {
          this.fieldOfficialState = this.officialStateStatus[[0]]
        }
        if ((this.$user.publicity.officialState === true) && (this.$user.publicity.officialOwnerIsMe === true)) {
          this.fieldOfficialState = this.officialStateStatus[[1]]
        }
        if ((this.$user.publicity.officialState === true) && (this.$user.publicity.officialOwnerIsMe === false)) {
          this.fieldOfficialState = this.officialStateStatus[[2]]
        }
      },
      internationalOrganizationStateLoader () {
        if ((this.$user.publicity.internationalOrganizationState === false) && (this.$user.publicity.internationalOrganizationOwnerIsMe === false)) {
          this.fieldInternationalOrganizationState = this.internationalOrganizationStateStatus[[0]]
        }
        if ((this.$user.publicity.internationalOrganizationState === true) && (this.$user.publicity.internationalOrganizationOwnerIsMe === true)) {
          this.fieldInternationalOrganizationState = this.internationalOrganizationStateStatus[[1]]
        }
        if ((this.$user.publicity.internationalOrganizationState === true) && (this.$user.publicity.internationalOrganizationOwnerIsMe === false)) {
          this.fieldInternationalOrganizationState = this.internationalOrganizationStateStatus[[2]]
        }
      },
      officialRussiaStateLoader () {
        if ((this.$user.publicity.officialRussiaState === false) && (this.$user.publicity.officialRussiaOwnerIsMe === false)) {
          this.fieldOfficialRussiaState = this.officialRussiaStateStatus[[0]]
        }
        if ((this.$user.publicity.officialRussiaState === true) && (this.$user.publicity.officialRussiaOwnerIsMe === true)) {
          this.fieldOfficialRussiaState = this.officialRussiaStateStatus[[1]]
        }
        if ((this.$user.publicity.officialRussiaState === true) && (this.$user.publicity.officialRussiaOwnerIsMe === false)) {
          this.fieldOfficialRussiaState = this.officialRussiaStateStatus[[2]]
        }
      },
      benefitsOfAnotherPerson () {
        (this.$user.publicity.benefitsOfAnotherPerson === false) ? this.fieldBenefitsOfAnotherPerson = this.benefitsOfAnotherPersonStatus[[0]] : this.fieldBenefitsOfAnotherPerson = this.benefitsOfAnotherPersonStatus[[1]]
      }
    },
    components: {
      ValidateMessage,
      Multiselect
    },
    methods: {
      showOfficialInfo () {
        this.officialInfoShow = !this.officialInfoShow
        if (this.officialInfoShow === false) {
          this.arrow = 'static/img/loan/modal-down.png'
        } else {
          this.arrow = 'static/img/loan/modal-up.png'
        }
      },
      getOfficialState (arg) {
        if (!arg.status) {
          this.$user.publicity.officialName = null
        }
        if (this.fieldOfficialState.id === 1) {
          this.$user.publicity.officialState = arg.status
          this.$user.publicity.officialOwnerIsMe = false
        } else if (this.fieldOfficialState.id === 2) {
          this.$user.publicity.officialState = arg.status
          this.$user.publicity.officialOwnerIsMe = true
        } else {
          this.$user.publicity.officialState = arg.status
          this.$user.publicity.officialOwnerIsMe = false
        }
      },
      getInternationalOrganizationState (arg) {
        if (!arg.status) {
          this.user.publicity.internationalOrganizationName = null
        }
        if (this.fieldInternationalOrganizationState.id === 1) {
          this.$user.publicity.internationalOrganizationState = arg.status
          this.$user.publicity.internationalOrganizationOwnerIsMe = false
        } else if (this.fieldInternationalOrganizationState.id === 2) {
          this.$user.publicity.internationalOrganizationState = arg.status
          this.$user.publicity.internationalOrganizationOwnerIsMe = true
        } else {
          this.$user.publicity.internationalOrganizationState = arg.status
          this.$user.publicity.internationalOrganizationOwnerIsMe = false
        }
      },
      getOfficialRussiaState (arg) {
        if (!arg.status) {
          this.$user.publicity.officialRussiaName = null
        }
        if (this.fieldOfficialRussiaState.id === 1) {
          this.$user.publicity.officialRussiaState = arg.status
          this.$user.publicity.officialRussiaOwnerIsMe = false
        } else if (this.fieldOfficialRussiaState.id === 2) {
          this.$user.publicity.officialRussiaState = arg.status
          this.$user.publicity.officialRussiaOwnerIsMe = true
        } else {
          this.$user.publicity.officialRussiaState = arg.status
          this.$user.publicity.officialRussiaOwnerIsMe = false
        }
      },
      getBenefitsOfAnotherPerson (arg) {
        this.$user.publicity.benefitsOfAnotherPerson = arg.status
      }
    },
    mounted () {
      this.$validator.localize(REQUIRED_FIELD)
      this.$validator.localize(MIN_LENGHT)
      this.$validator.localize(MAX_LENGHT)
      this.$user.validate.step3.publicInformation = true
    },
    updated () {
      this.$user.validate.step3.publicInformation = Object.keys(this.$validator.flags).reduce((acc, item) => acc && this.$validator.flags[item].valid, true)
    }
  }
</script>

<style scoped lang="scss">
  .slide-fade-enter-active {
    transition: all .3s ease
  }

  .slide-fade-leave-active {
    transition: all .3s ease;
  }

  .slide-fade-enter, .slide-fade-leave-to {
    transform: translateY(10px);
    opacity: 0;
  }

  .slide-fade-leave-to {
    transform: translateY(10px);
    opacity: 0;
  }
</style>
